#
# ApplicationManager
#
from time import time
from urllib import unquote_plus

import Globals
from App.ApplicationManager import ApplicationManager as ZopeApplicationManager
from ZODB.Mount import dbs

def _getDB(key):
    return dbs.get(key)[0]

# getDBKeys
def getDBKeys(self):
    return dbs.keys()
ZopeApplicationManager.getDBKeys = getDBKeys

# getDBMountCount
def getDBMountCount(self,key):
    return len(dbs.get(key)[1])
ZopeApplicationManager.getDBMountCount = getDBMountCount

# db_name
if not hasattr(ZopeApplicationManager, '_db_name'):
    ZopeApplicationManager._db_name = ZopeApplicationManager.db_name
def db_name(self,key=None):
    if key is None:
        return self._db_name()
    else:
        db = _getDB(key)
        return db.getName()
ZopeApplicationManager.db_name = db_name

# db_size
if not hasattr(ZopeApplicationManager, '_db_size'):
    ZopeApplicationManager._db_size = ZopeApplicationManager.db_size
def db_size(self,key=None):
    if key is None:
        return self._db_size()
    else:
        db = _getDB(key)
        s=db.getSize()
        if type(s) is type(''): return s
        if s >= 1048576.0: return '%.1fM' % (s/1048576.0)
        return '%.1fK' % (s/1024.0)
ZopeApplicationManager.db_size = db_size

# manage_pack
if not hasattr(ZopeApplicationManager, '_manage_pack'):
    ZopeApplicationManager._manage_pack = ZopeApplicationManager.manage_pack
def manage_pack(self,days=0,key=None,REQUEST=None):
    """Pack the database"""
    if key is None:
        return self._manage_pack(days=days,REQUEST=REQUEST)
    else:
        key = unquote_plus(key)
        db = _getDB(key)
        t=time()-days*86400
        t = db.pack(t)
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(
                REQUEST['URL1']+'/manage_mounts')
        return t
ZopeApplicationManager.manage_pack = manage_pack

#
# DatabaseManager
#
from App.ApplicationManager import DatabaseManager as ZopeDatabaseManager

# manage_options
if not hasattr(ZopeDatabaseManager, '_manage_options'):
    ZopeDatabaseManager._manage_options = ZopeDatabaseManager.manage_options
ZopeDatabaseManager.manage_options = ZopeDatabaseManager._manage_options+(
    {'label':'Mounts', 'action':'manage_mounts',
     'help':('OFSP','Database-Management_Mounts.stx')},
    )

ZopeDatabaseManager.manage_mounts=Globals.DTMLFile('dtml/dbMounts', globals())
