""" Support for mounting a filestorage. 
    Code derived from the original OFS/MountedItem.py which has now disappeared
    from the CVS.

    Use at your own risk. There's probably gods only know special badness 
    awaiting users of this. 
"""

import string
import AccessControl.SecurityManagement, AccessControl.User
import ZODB, ZODB.ZApplication
import Globals, OFS.Application

from MountedItem import MountedItem

def params_canonical_repr(hash):
    if type(hash) == type(''):
        hash = eval(hash)
    r = '{'
    keys = hash.keys()
    keys.sort()
    for k in keys:
        r = r + ''''%s':'%s',''' % (k,hash[k])
    r = r + '}'
    return r

class MountedStorageMixin:
    def _createStorage(self): pass

    def _createDB(self):
	""" Gets the database object, usually by creating a Storage object
        and returning ZODB.DB(storage).
        """
        params = eval(self._params)
        path = self._path
        create = self._create
        DB = ZODB.DB(self._createStorage())
        #
        # Excerpt from lib/python/Zope/__init__.py
        #
        # "Log on" as system user
        AccessControl.SecurityManagement.newSecurityManager(
            None, AccessControl.User.system)
        
        # Set up the "application" object that automagically opens
        # connections
        app=ZODB.ZApplication.ZApplicationWrapper(
            DB, 'Application', OFS.Application.Application, (),
            Globals.VersionNameName)
        
        # Initialize products:
        c=app()
        if create:
            obj=c
            for p in string.split(path[1:], '/'):
                if obj._getOb(p,None) is None:
                    from OFS.Folder import Folder
                    folder = Folder()
                    folder.id = p
                    obj._setObject(p, folder)
                    get_transaction().note('Added Folder with id %s' % p)
                    get_transaction().commit()
                obj = obj._getOb(p)

        c._p_jar.close()
        del c

        # "Log off" as system user
        AccessControl.SecurityManagement.noSecurityManager()

        return DB

class MountedStorage(MountedStorageMixin, MountedItem):
    '''A MountPoint with a basic interface for displaying the
    reason the database did not connect.
    '''

    meta_type = 'MountedStorage'
    
    icon = 'p_/broken'
    manage_options = ({'label':'Traceback', 
                       'action':'manage_traceback'},)
    manage_traceback = Globals.HTMLFile('dtml/mountfail', globals())

    def __init__(self, id, title='', path=None, create=None, params={}):
        self.title = title
        # check path
        if path is None or path == '' or path == '/':
            path = '/'
        if path[0] != '/':
            path = '/' + path
        if len(path) > 1 and path[len(path) - 1] != '/':
            path = path + '/'
        # add id
        path = path + id
        # params_repr+_create
        self._create = create
        params_repr = params_canonical_repr(params)
        # MountedItem
        MountedItem.__init__(self,path,params_repr)
